﻿using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using StreamEntityFrameworkOverWebApi.Data;

namespace StreamEntityFrameworkOverWebApi.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class ProductsController : ControllerBase
    {
        private readonly SalesContext _salesContext;

        public ProductsController (SalesContext salesContext)
        {
            _salesContext = salesContext;
        }
        [HttpGet("nonstreaming/")]
        public async Task<ActionResult> GetNonStreaming()
        {
            List<Product> products = await _salesContext.Products.ToListAsync();

            return Ok(products);
        }

        [HttpGet("streaming/")]
        public ActionResult GetStreaming()
        {
            IQueryable<Product> products = _salesContext.Products.AsNoTracking();

            return Ok(products);
        }

        // GET api/values/5
        [HttpGet("{productId}")]
        public ActionResult<string> Get(int productId)
        {
            Product product = _salesContext.Products.SingleOrDefault(p => p.ProductId == productId);

            return Ok(product);
        }
    }
}
